/* This is Test1 */
#include <stdio.h>
#include "second.h"

void
report (int nx, int lx, float op, float tm)
{
  float mf = -1.;
  if (tm > 0.)
    mf = op / tm;
  printf ("%10d%10d%10.2f%10.2f\n", nx, lx, tm, mf);
}

extern void dist (float *, float *, float *, int);
#define NM 400

void
main (int argc, char *argv[])
{
  int i, j, lx;
  float op, tm;

  float u[3 * NM], v[3 * NM], d[NM];

  for (i = 0; i < 3 * NM; i += 3)
    {
      u[i+0] = (i%3) + 1;
      v[i+0] = 4 - u[i+0];
      u[i+1] = (i%3) + 2;
      v[i+1] = 4 - u[i+1];
      u[i+2] = (i%3) + 3;
      v[i+2] = 4 - u[i+2];
    }
  lx = 1;
  if (argc > 1)
    sscanf (argv[1], "%d", &lx);
  tm = second ();
  for (i = 0; i < lx; i++)
    for (j = 0; j < 3 * NM; j += 3)
      dist (u, v + j, d, NM);
  tm = second () - tm;
  op = (1.e-3 * NM) * (8 * NM) * (1.e-3 * lx);
  report (NM, lx, op, tm);
  exit(0);
}
void
dist (float *u, float *v, float *d, int n)
{
  int i, i3, m;
  float v0, v1, v2, t0, t1, t2, t3, t4, t5;
#ifdef HELP_GCC
  float u0, u1, u2, u3, u4, u5, u6, u7, u8, u9, u10, u11;
  float t6, t7;
#endif

  v0 = v[0];
  v1 = v[1];
  v2 = v[2];
  m = n & ~3L;
  for (i = i3 = 0; i < m; i += 4, i3 += 12)
    {
#ifdef HELP_GCC

#if 0
      u0 = u[i3 + 0]; u1 = u[i3 + 1];  u2 = u[i3 + 2];   u3 = u[i3 + 3];
      u4 = u[i3 + 4]; u5 = u[i3 + 5];  u6 = u[i3 + 6];   u7 = u[i3 + 7];
      u8 = u[i3 + 8]; u9 = u[i3 + 9]; u10 = u[i3 + 10]; u11 = u[i3 + 11];

      t0 = u0 - v0;
      t1 = u1 - v1;
      t2 = u2 - v2;
      t0 *= t0;
      t1 *= t1;
      t0 += t1;
      t3 = u3 - v0;
      t2 *= t2;
      t0 += t2;
      t4 = u4 - v1;
      t5 = u5 - v2;
      t3 *= t3;
      t4 *= t4;
      t3 += t4;
      t5 *= t5;
      t3 += t5;
      t6 = t0;
      t0 = u6 - v0;
      t1 = u7 - v1;
      t2 = u8 - v2;
      t7 = t3;
      t0 *= t0;
      t1 *= t1;
      t0 += t1;
      t2 *= t2;
      t0 += t2;
      t3 = u9 - v0;
      t4 = u10 - v1;
      t5 = u11 - v2;
      t3 *= t3;
      t4 *= t4;
      t3 += t4;
      t5 *= t5;
      t3 += t5;
      d[i + 0] = t6;
      d[i + 1] = t7;
      d[i + 2] = t0;
      d[i + 3] = t3;
# else
      u0 = u[i3 + 0];
      u1 = u[i3 + 1];
      u2 = u[i3 + 2];
      u3 = u[i3 + 3];
      u4 = u[i3 + 4];
      u5 = u[i3 + 5];
      u6 = u[i3 + 6];
      u7 = u[i3 + 7];
      u8 = u[i3 + 8];
      u9 = u[i3 + 9];
      u10 = u[i3 + 10];
      u11 = u[i3 + 11];

      t0 = u0 - v0;
      t1 = u1 - v1;
      t2 = u2 - v2;
      t0 *= t0;
      t1 *= t1;
      t0 += t1;
      t3 = u3 - v0;
      t2 *= t2;
      t0 += t2;
      t4 = u4 - v1;
      t5 = u5 - v2;
      t3 *= t3;
      t4 *= t4;
      t3 += t4;
      t5 *= t5;
      t3 += t5;
      t6 = u6 - v0;
      t1 = u7 - v1;
      t2 = u8 - v2;
      t6 *= t6;
      t1 *= t1;
      t6 += t1;
      t2 *= t2;
      t6 += t2;
      t7 = u9 - v0;
      t4 = u10 - v1;
      t5 = u11 - v2;
      t7 *= t7;
      t4 *= t4;
      t7 += t4;
      t5 *= t5;
      t7 += t5;
      d[i] = t0;
      d[i + 1] = t3;
      d[i + 2] = t6;
      d[i + 3] = t7;
# endif
#else
      t0 = u[i3 + 0] - v0;
      t1 = u[i3 + 1] - v1;
      t2 = u[i3 + 2] - v2;
      t0 *= t0;
      t1 *= t1;
      t0 += t1;
      t3 = u[i3 + 3] - v0;
      t2 *= t2;
      t0 += t2;
      t4 = u[i3 + 4] - v1;
      t5 = u[i3 + 5] - v2;
      t3 *= t3;
      t4 *= t4;
      t3 += t4;
      t5 *= t5;
      t3 += t5;
      d[i] = t0;
      t0 = u[i3 + 6] - v0;
      t1 = u[i3 + 7] - v1;
      t2 = u[i3 + 8] - v2;
      d[i + 1] = t3;
      t0 *= t0;
      t1 *= t1;
      t0 += t1;
      t2 *= t2;
      t0 += t2;
      t3 = u[i3 + 9] - v0;
      t4 = u[i3 + 10] - v1;
      t5 = u[i3 + 11] - v2;
      t3 *= t3;
      t4 *= t4;
      t3 += t4;
      t5 *= t5;
      t3 += t5;
      d[i + 2] = t0;
      d[i + 3] = t3;
#endif
    }
  
  for (i = m, i3 = 3 * m; i < n; i++, i3 += 3)
    {
      t0 = u[i3 + 0] - v0;
      t1 = u[i3 + 1] - v1;
      t0 *= t0;
      t2 = u[i3 + 2] - v2;
      t1 *= t1;
      t2 *= t2;
      t0 += t1;
      t0 += t2;
      d[i] = t0;
    }
}
