/* This is Test2 */
# include <stdio.h>
#include "second.h"

#define VECLEN 512
#define LOOP 1000

void rot (float *, float *, float *, int);

void
main (int argc, char *argv[])
{
  float f1, t1;
  long i, n;
  float r[12] = {
    0., 0., 1., 1.,
    2., 0., 0., 2.,
    0., 3., 0., -1. };
  float x[3*VECLEN], y[3*VECLEN];
  for (i = 0; i < 3*VECLEN; i++)
    x[i] = (i % 3) + 1;

  if (argc == 1)
    n=10;
  else
    sscanf (argv[1], "%ld", &n);

  printf("Transf Benchmark: loop length   : %5ld * %d\n", n, VECLEN);
  n*=LOOP;
  t1=second();

  for (i=0; i<n; i++)
    rot (r, x, y, VECLEN);

#ifdef DEBUG

  printf ("%f %f %f %f %f %f\n",
	  x[0], x[1], x[2],
	  y[0], y[1], y[2]);
  printf ("%f %f %f %f %f %f\n",
	  x[3*VECLEN-3], x[3*VECLEN-2], x[3*VECLEN-1],
	  y[3*VECLEN-3], y[3*VECLEN-2], y[3*VECLEN-1]);

#endif

  t1=second() - t1;
  if (t1 > 0.)
    f1=18.e-3*n/t1;
  else
    f1=-1.;
  printf("Transf Benchmark: Time/MegaFlops: %10.2f %10.2f\n", t1, f1);
  exit(0);
}

void
rot (float *r, float *x, float *y, int n)
{
  int i, i3;
  float t0, t1, t2, t3, t4, t5;
#ifdef HELP_GCC
  float r0, r1, r2, r3, r4, r5, r6, r7, r8, r9, r10, r11;

  r0 = r[0]; r1 = r[1]; r2 = r[2]; r3 = r[3]; r4 = r[4];
  r5 = r[5]; r6 = r[6]; r7 = r[7]; r8 = r[8]; r9 = r[9];
  r10 = r[10]; r11 = r[11];
#endif

  for (i = i3 = 0; i < n; i++, i3 += 3)
    {
#ifdef HELP_GCC
      float o0, o1;
      float x0, x1, x2;

      x0 = x[i3 + 0]; x1 = x[i3 + 1]; x2 = x[i3 + 2];

      t0 = r4;
      t1 = r0 * x0;
      t2 = r1 * x1;
      t0 += t1;
      t1 = r2 * x2;
      t0 += t2;
      t0 += t1;
      o0 = t0;
      y[i3 + 0] = o0;

      t3 = r7;
      t4 = r4 * x0;
      t5 = r5 * x1;
      t3 += t4;
      t4 = r6 * x2;
      t3 += t5;
      t3 += t4;
      o1 = t3;
      y[i3 + 1] = o1;

      t0 = r11;
      t1 = r8 * x0;
      t2 = r9 * x1;
      t0 += t1;
      t1 = r10 * x2;
      t0 += t2;
      t0 += t1;

      y[i3 + 2] = t0;
#else
      t0 = r[4];
      t1 = r[0] * x[i3 + 0];
      t2 = r[1] * x[i3 + 1];
      t0 += t1;
      t1 = r[2] * x[i3 + 2];
      t0 += t2;
      t0 += t1;

      t3 = r[7];
      t4 = r[4] * x[i3 + 0];
      t5 = r[5] * x[i3 + 1];
      t3 += t4;
      t4 = r[6] * x[i3 + 2];
      t3 += t5;
      y[i3 + 0] = t0;
      t3 += t4;

      t0 = r[11];
      t1 = r[8] * x[i3 + 0];
      t2 = r[9] * x[i3 + 1];
      t0 += t1;
      t1 = r[10] * x[i3 + 2];
      t0 += t2;
      y[i3 + 1] = t3;
      t0 += t1;

      y[i3 + 2] = t0;
#endif
    }
}
